'--------------------------------------------------------------------------
'  DeMo-NFOrce.vbs Script
'
' This script was based on the original NFOrce Script by InVisage
' It has been modified to work with the current NFOrce website.
'
'
' I rewrote it from scratch using RegExp instead of InStr functions.
' Regular Expressions roX!!
'
'
' This is version 4.1
' Contact me @ http://www.samurize.com/modules/ipboard/index.php?showuser=230
'
'--------------------------------------------------------------------------


'----------------- CONFIGURATION -----------------
Const NFORCE_ADDR = "http://www.nforce.nl/"	'NFOrce's website address
Const NO_FILTERED = "No releases..."		'Message to show when no releases passed filter settings

'This version lets you customize the output through "smart tags"
'All you have to do is provide a string along with the following tags:
'<title> Is replaced by the release name (ie: SomeGame (C) 2003 - SomeCompany)
'<group> Is replaced by the group who released (ie: Fairlight)
'<date> Is replaced with the release date (ie: 2003-11-04)
'<size> Is replaced with the release size (ie: 90x15 MB)
'<rating> Is replaced with the release rating (user votes)
'<type> Only showed if you use the GetMixedList function, replaced by the release type (ie: PC Game ISO)

'Now lets go for a quick example.
'If you set the RELEASE_FORMAT Const below to: "In <date>, <group> released: <title>"
'The result would be: "In 2003-11-04, DeMo release: NFOrce Script v3.0"

'Another example: "<title> by <group>"
'The result is: "NFOrce Script v3.0 by DeMo"

'You can use any characters you want as long as you keep the tags enclosed by the < >
'One more example: "<title> by -==[<group>]==-"
'Result: "NFOrce Script v4.1 by -==[DeMo]==-"

'I think you got it..
'Now set the RELEASE_FORMAT to wathever you like! <date> | <title> | <rating> | <group>

Const RELEASE_FORMAT = "<date>%tab<title> -=[<group>]=-"
'----------------- CONFIGURATION -----------------



'----------------- DO NOT CHANGE ANYTHING BELOW THIS LINE!!! -----------------

Function GetMixedList(NUMBER_OF_RELEASES, Filter)
    GetMixedList = getISOReleases("l", NUMBER_OF_RELEASES, Filter)
End Function

Function GetPCRipz(NUMBER_OF_RELEASES, Filter)
    GetPCRipz = getISOReleases(1, NUMBER_OF_RELEASES, Filter)
End Function

Function GetPCiSO(NUMBER_OF_RELEASES, Filter)
    GetPCiSO = getISOReleases(2, NUMBER_OF_RELEASES, Filter)
End Function

Function GetPCAddons(NUMBER_OF_RELEASES, Filter)
    GetPCAddons = getISOReleases(3, NUMBER_OF_RELEASES, Filter)
End Function

Function GetPCRipPatches(NUMBER_OF_RELEASES, Filter)
    GetPCRipPatches = getISOReleases(4, NUMBER_OF_RELEASES, Filter)
End Function

Function GetPCDOX(NUMBER_OF_RELEASES, Filter)
    GetPCDOX = getISOReleases(5, NUMBER_OF_RELEASES, Filter)
End Function

Function GetPCAppiSO(NUMBER_OF_RELEASES, Filter)
    GetPCAppiSO = getISOReleases(6, NUMBER_OF_RELEASES, Filter)
End Function

Function GetDreamcast(NUMBER_OF_RELEASES, Filter)
    GetDreamcast = getISOReleases(7, NUMBER_OF_RELEASES, Filter)
End Function

Function GetPlaystation(NUMBER_OF_RELEASES, Filter)
    GetDreamcast = getISOReleases(8, NUMBER_OF_RELEASES, Filter)
End Function

Function GetPlaystation2(NUMBER_OF_RELEASES, Filter)
    GetPlaystation2 = getISOReleases(9, NUMBER_OF_RELEASES, Filter)
End Function

Function GetGBA(NUMBER_OF_RELEASES, Filter)
    GetGBA = getISOReleases(10, NUMBER_OF_RELEASES, Filter)
End Function

Function GetXBOX(NUMBER_OF_RELEASES, Filter)
    GetXBOX = getISOReleases(11, NUMBER_OF_RELEASES, Filter)
End Function

Function GetGameCube(NUMBER_OF_RELEASES, Filter)
    GetGameCube = getISOReleases(20, NUMBER_OF_RELEASES, Filter)
End Function

Function GetDiVX(NUMBER_OF_RELEASES, Filter)
    GetDiVX = getISOReleases(12, NUMBER_OF_RELEASES, Filter)
End Function

Function GetXviD(NUMBER_OF_RELEASES, Filter)
    GetXviD = getISOReleases(13, NUMBER_OF_RELEASES, Filter)
End Function

Function GetVCD(NUMBER_OF_RELEASES, Filter)
    GetVCD = getISOReleases(14, NUMBER_OF_RELEASES, Filter)
End Function

Function GetSVCD(NUMBER_OF_RELEASES, Filter)
    GetSVCD = getISOReleases(15, NUMBER_OF_RELEASES, Filter)
End Function

Function GetAnime(NUMBER_OF_RELEASES, Filter)
    GetAnime = getISOReleases(16, NUMBER_OF_RELEASES, Filter)
End Function

Function GetXXX(NUMBER_OF_RELEASES, Filter)
    GetXXX = getISOReleases(17, NUMBER_OF_RELEASES, Filter)
End Function

Function GetTVRiPS(NUMBER_OF_RELEASES, Filter)
    GetTVRiPS = getISOReleases(19, NUMBER_OF_RELEASES, Filter)
End Function

Function GetDVDR(NUMBER_OF_RELEASES, Filter)
    GetDVDR = getISOReleases(18, NUMBER_OF_RELEASES, Filter)
End Function

Function getISOReleases(Section, TOTALRLS, Filter)


    Dim htmlResult
    ReDim strTitle(TOTALRLS), strGrp(TOTALRLS), strSize(TOTALRLS), strType(TOTALRLS), strRate(TOTALRLS), strDate(TOTALRLS), strRelease(TOTALRLS)

    If Section = "l" Then
        htmlResult = ReturnHTML(NFORCE_ADDR & "index.php?m=mixed")
    Else
        htmlResult = ReturnHTML(NFORCE_ADDR & "index.php?m=sections&id=" & Section)
    End If


    WorkingResult = htmlResult

    
    Set RE = New RegExp
    RE.Global = True

    'Remove links to NFO details
    'RE.Pattern = "<a href=""[?]do=nfo&id=[\d]{1,10}"">"
    'WorkingResult = RE.Replace(WorkingResult, "")

    'Remove </a> tags
    'RE.Pattern = "</a>"
    'WorkingResult = RE.Replace(WorkingResult, "")
    
    If Section = "l" Then

        'Get type
        RE.Pattern = "href=""[?]m=sections&id=[\d]{1,2}"">(.*?)</a></TD>"
        Set typetemp = RE.Execute(WorkingResult)
	For i = 0 To TOTALRLS - 1
		Set oMatch = typetemp(i)
		strType(i) = oMatch.SubMatches(0)
	Next

	'Get Rating
	RE.Pattern = "old_m=mixed"">(.*?)</a></div>"
	Set ratetemp = RE.Execute(WorkingResult)
	For i = 0 To TOTALRLS - 1
		Set oMatch = ratetemp(i)
		strRate(i) = oMatch.SubMatches(0)
		If strRate(i) = "&nbsp;&middot;&nbsp;" Then
			strRate(i) = "NR"
		End If
	Next
        
    End If

    'Get Date
    RE.Pattern = "[0-9]{4}[-][0-9]{2}[-][0-9]{2}"

    Set datetemp = RE.Execute(WorkingResult)

    For i = 0 To TOTALRLS -1
	strDate(i) = datetemp(i)
    Next


    'Get Name
     RE.Pattern = "&nbsp;&nbsp;(.*?)</A></TD>"

    Set titletemp = RE.Execute(WorkingResult)

    For i = 0 To TOTALRLS - 1
      Set oMatch = titletemp(i)
      strTitle(i) = oMatch.SubMatches(0)
    Next
    
    'Get Size
    RE.Pattern = "class=white>(.*?) MB</td>"

    Set sizetemp = RE.Execute(WorkingResult)

    For i = 0 To TOTALRLS - 1
      Set oMatch = sizetemp(i)
      strSize(i) = oMatch.SubMatches(0) & "MB"
    Next

    'Get Group
    RE.Pattern = "1&group=(.*?)"">"

    Set grptemp = RE.Execute(WorkingResult)

    For i = 0 To TOTALRLS - 1
      Set oMatch = grptemp(i)
      strGrp(i) = oMatch.SubMatches(0)
    Next

    If Section <> "l" Then    

        'Get Rating
        RE.Pattern = "old_m=sections"">(.*?)</a></div>"
        Set ratetemp = RE.Execute(WorkingResult)
        For i = 0 To TOTALRLS - 1
            Set oMatch = ratetemp(i)
            strRate(i) = oMatch.SubMatches(0)
            If strRate(i) = "&nbsp;&middot;&nbsp;" Then
                strRate(i) = "NR"
            End If
        Next
    End If

    
    For b = 0 To TOTALRLS - 1
	'Generate full release string
	strRelease(b) = RELEASE_FORMAT
	strRelease(b) = Replace(strRelease(b), "<group>", strGrp(b), 1, -1, 1)
	strRelease(b) = Replace(strRelease(b), "<title>", strTitle(b), 1, -1, 1)
	strRelease(b) = Replace(strRelease(b), "<size>", strSize(b), 1, -1, 1)
	strRelease(b) = Replace(strRelease(b), "<rating>", strRate(b), 1, -1, 1)
	strRelease(b) = Replace(strRelease(b), "<date>", strDate(b), 1, -1, 1)
	If Section = "l" Then
	    strRelease(b) = Replace(strRelease(b), "<type>", strType(b), 1, -1, 1)
	End if
    Next

    'Create the filter array
    If Filter <> "" Then FilterArray = Split(Filter, "|")

    For b = 0 To TOTALRLS - 1
        If Filter <> "" Then
            For c = 0 To UBound(FilterArray)
                If InStr(1, LCase(strRelease(b)), LCase(FilterArray(c))) > 0 Then
                    getISOReleases = getISOReleases & strRelease(b) & vbCrLf
                End If
            Next
        Else
            getISOReleases = getISOReleases & strRelease(b) & vbCrLf
        End If
    Next

    'Check if any releases passed filter settings
    If getISOReleases = "" Then
        getISOReleases = NO_FILTERED
    End If

End Function


Function ReturnHTML(sURL)
    Randomize
    Dim objXMLHTTP, HTML
    Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
    objXMLHTTP.Open "GET", sURL, False
    objXMLHTTP.Send
    HTML = objXMLHTTP.responseBody
    Set objRS = CreateObject("ADODB.Recordset")
    objRS.Fields.Append "txt", 200, 45000, &H80
    objRS.Open
    objRS.AddNew
    objRS.Fields("txt").AppendChunk HTML
    ReturnHTML = objRS("txt").Value
    objRS.Close
    Set objRS = Nothing
    Set objXMLHTTP = Nothing
End Function
